;
; Landscapegenerator for MXM AirFights
; by MXM Projects
; http://members.vol.at/schoenach
	include "flib.h"
	xdef _library
	xdef landscap@0000
	xdef landscap@0001


; This random is used for generating the same landscape in each level!

landscape_random:

; This random is only a demonstration
; We tried to change the RANDOM routine from FLIB to get a some better results.
; In	D0	upper limit
; Out	D0	0..upperlimit-1

	movem.l	d1,-(a7)
	move.w	landscape_random_seed,d1

; This factor should be lower than 2^15 [32768]

	mulu.w	#30613,d1
	add.w	#2719,d1
	mulu.w	d1,d0

; You have to set a new seed, else you would always get the same result!

	move.w	d1,landscape_random_seed
	clr.w	d0
	swap	d0
	movem.l	(a7)+,d1
	rts


; This routine put a sprite [ 8 * 8 ] to the screen
; In:	D0	-> X [0 .. 28]
;	A1	-> Sprite
putsprite8x8:
	movem.l d0-d2/a0,-(a7)
	move.w #7,d2
	adda.w d0,a0
_copyloop:
	move.b (a1)+,(a0)
	lea 30(a0),a0
	dbra.w d2,_copyloop
	movem.l (a7)+,d0-d2/a0
	rts

; Generete a line of the landscape:
; In:	A0	-> Pointer to this row
; Return nothing, the program will ignore that!
; You can use all registers [Avoid A0]

landscap@0000:
generate_landscape_line:
; 3 random stars

	move.w #2,d2
createlineloop:
	move.w #239,d0
	bsr landscape_random
	move.w d0,d3
	lsr.w #3,d3
	not.w d0
	and.w #7,d0
	bset.b d0,0(a0,d3.w)
	dbra.w d2,createlineloop
; Set 1 Planet?
	move.w #100,d0
	bsr landscape_random
	cmp.w #59,d0
	bne _realend
	move.w #3,d0
	bsr landscape_random
	lsl.w #3,d0
	lea sprite1(PC),a1
	adda.w d0,a1
	move.w #29,d0
	bsr landscape_random
	bsr putsprite8x8
_realend:
	rts

; To create always the same landscape we need our own randomroutine. This
; routine has to have a SEED. To set this SEED the label landscap@0001 is
; needed.

landscap@0001:
landscape_random_seed	dc.w 0
sprite1		dc.b %00000000,
		dc.b %00111100,
		dc.b %01110010,
		dc.b %11100001,
		dc.b %11000001,
		dc.b %01000010,
		dc.b %00111100,
		dc.b %00000000,
		dc.b %00000000,
		dc.b %00000000,
		dc.b %00011000,
		dc.b %01111110,
		dc.b %11111111,
		dc.b %01111110,
		dc.b %00011000,
		dc.b %00000000,
		dc.b %00000000,
		dc.b %00000000,
		dc.b %00000000,
		dc.b %00011000,
		dc.b %00111100,
		dc.b %00011000,
		dc.b %00000000,
		dc.b %00000000

_library	dc.b "landscap",0
	END